!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!
! Copyright (c) 2017, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Nikhil C. Admal
!    Min Shi
!    Ellad B. Tadmor
!
! Release: This file is part of the MDStressLab git repository.
!
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! File lsqrDataModule.f90
!
! Defines real(kind=dp) and a few constants for use in other modules.
!
! 24 Oct 2007: Allows floating-point precision dp to be defined
!              in exactly one place (here).  Note that we need
!                 use lsqrDataModule
!              at the beginning of modules AND inside interfaces.
!              zero and one are not currently used by LSQR,
!              but this shows how they should be declared
!              by a user routine that does need them.
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

module lsqrDataModule

  implicit none

  intrinsic                   ::      selected_real_kind
  integer,  parameter, public :: dp = selected_real_kind(p=15,r=307)
  integer,  parameter, public :: qp = selected_real_kind(p=33,r=4931)
  real(kind=dp), parameter, public :: zero = 0.0_dp, one = 1.0_dp

end module lsqrDataModule
