!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!
! Copyright (c) 2017, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Nikhil C. Admal
!    Min Shi
!    Ellad B. Tadmor
!
! Release: This file is part of the MDStressLab git repository.
!
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! File lsqrblasInterface.f90
!
!    BLAS1 Interfaces:   ddot    dnrm2    dscal
!
! Maintained by Michael Saunders <saunders@stanford.edu>.
!
! 19 Dec 2008: lsqrblasInterface module implemented.
!              Metcalf and Reid recommend putting interfaces in a module.
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

module lsqrblasInterface

  implicit none
  public   :: ddot, dnrm2, dscal

  interface                              ! Level 1 BLAS
     function ddot(n,dx,incx,dy,incy)
       use lsqrDataModule, only : dp
       integer,  intent(in)         :: n,incx,incy
       real(kind=dp), intent(in)    :: dx(:),dy(:)
       real(kind=dp)                :: ddot
     end function ddot

     function dnrm2(n,dx,incx)
       use lsqrDataModule, only : dp
       integer,  intent(in)         :: n,incx
       real(kind=dp), intent(in)    :: dx(:)
       real(kind=dp)                :: dnrm2
     end function dnrm2

     subroutine dscal(n,sa,x,incx)
       use lsqrDataModule, only : dp
       integer,  intent(in)    :: n,incx
       real(kind=dp), intent(in)    :: sa
       real(kind=dp), intent(inout) :: x(:)
     end subroutine dscal
  end interface

end module lsqrblasInterface
