!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!
! Copyright (c) 2017, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Nikhil C. Admal
!    Min Shi
!    Ellad B. Tadmor
!
! Release: This file is part of the MDStressLab git repository.
!
!****************************************************************************
!**
!**   MODULE mod_global: Global settings
!**
!**   type definitions:
!**   ----------------
!**   N/A
!**
!**   Real Variable Definitions:
!**   -------------------------------------
!**   PI - The ratio of a circle's circumference to its diameter
!**
!**   Integer Variable Definitions:
!**   ----------------------------
!**   dp - definition of double precision for portability
!**  
!**   logical Variable Definitions:
!**   ----------------------------
!**   N/A
!**
!**   Contains Routines:
!**   ------------------
!**   N/A
!**
!****************************************************************************
module mod_global
implicit none
save
private
public cmdunit,dp,qp,PI,PI_QP
! p = precision = number of decimal digits
! r = range = exponent required in powers of 10
integer, parameter :: dp = selected_real_kind(p=15,r=307)
integer, parameter :: qp = selected_real_kind(p=33,r=4931)
real(kind=dp), PARAMETER :: PI = 3.141592653589793_dp
real(kind=qp), PARAMETER :: PI_QP = 3.141592653589793238462643383279502884197169399375105820975_qp
integer :: cmdunit
end module mod_global
