!
! CDDL HEADER START
!
! The contents of this file are subject to the terms of the Common Development
! and Distribution License Version 1.0 (the "License").
!
! You can obtain a copy of the license at
! http://www.opensource.org/licenses/CDDL-1.0.  See the License for the
! specific language governing permissions and limitations under the License.
!
! When distributing Covered Code, include this CDDL HEADER in each file and
! include the License file in a prominent location with the name LICENSE.CDDL.
! If applicable, add the following below this CDDL HEADER, with the fields
! enclosed by brackets "[]" replaced with your own identifying information:
!
! Portions Copyright (c) [yyyy] [name of copyright owner]. All rights reserved.
!
! CDDL HEADER END
!
! Copyright (c) 2017, Regents of the University of Minnesota.
! All rights reserved.
!
! Contributors:
!    Nikhil C. Admal
!    Min Shi
!    Ellad B. Tadmor
!
! Release: This file is part of the MDStressLab git repository.
!
!****************************************************************************
!**
!**   MODULE mod_types : type definitions used by other modules
!**
!**   type definitions:
!**   ----------------
!**   type(spec) variables:
!**         %mass - mass of the species
!**
!**   Real Variable Definitions:
!**   -------------------------------------
!**   N/A
!**
!**   Integer Variable Definitions:
!**   ----------------------------
!**   N/A
!**  
!**   logical Variable Definitions:
!**   ----------------------------
!**   N/A
!**
!**   Contains Routines:
!**   ------------------
!**   N/A
!****************************************************************************

module mod_types
use mod_global, only: dp
implicit none
save
private
public species,neighObjFullType,bin_at,bin_grid,bin_neighbor_list

type species
    character(len=3) :: element
    real(kind=dp) :: mass
end type species

type neighObjFullType
    integer, allocatable :: neighborList(:,:) ! This is bad when the atoms have big diverse # neighbors
end type neighObjFullType

type bin_at
    integer, allocatable, dimension(:) :: bin_atomlist ! bin(binid)%bin_atomlist(natoms) = iatomid
    integer :: natoms = 0 ! number of atoms in this bin
end type bin_at

type bin_grid
    integer, allocatable, dimension(:) :: bin_atomlist ! bin(binid)%bin_atomlist(natoms) = iatomid
    integer, allocatable, dimension(:) :: bin_gridlist ! bin(binid)%bin_atomlist(ngrid) = igridid
    integer :: natoms = 0 ! number of atoms in this bin
    integer :: ngrid = 0 ! number of grids in this bin
end type bin_grid

type bin_neighbor_list
    integer, allocatable, dimension(:) :: neigh ! bin_neighbor_list(atomid)%neigh(nneigh)
    integer :: nneigh = 0
end type bin_neighbor_list

end module mod_types
